/******************************************************
 * Project:    
 * Author:  
 * ATmega64
 * 16,000000 MHz
 * Ver: 1.02
*****************************************************/
#include <mega64.h>
#include <delay.h>
#include <stdio.h>
#include <stdlib.h>
#include <1wire.h>
#include <ds18b20.h>
#include <sleep.h>
#include "strel_sp.h"
#include "symvol.h"

#define byte unsigned char

//    lcd
#define sclk    PORTC.0
#define sda     PORTC.1
#define cs      PORTC.2
#define rst     PORTC.3

#define CMD        0
#define DATA       1

#define ADC_VREF_TYPE 0xE0

// 1 Wire Bus functions
#asm
   .equ __w1_port=0x15 ;PORTC
   .equ __w1_bit=4
#endasm


// DS1302 Real Time Clock functions
#asm
   .equ __ds1302_port=0x15 ;PORTC
   .equ __ds1302_io=5
   .equ __ds1302_sclk=6
   .equ __ds1302_rst=7
#endasm
#include <ds1302.h>

//=====================ADC===============================
// Read the 8 most significant bits
// of the AD conversion result
unsigned char read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCH;
}
//===================end ADC=============================

// 
void init (void);
void calc_speed(void);
void calc_taxo (void);
void Lcd_Clear(void);
void Lcd_Init(void);
void Lcd_Write(char cd,unsigned char c);
void SetX(char x);
//void SetY(char y);
void Gotoxy(char x,char y);
void VLine(char x,char y);
void LCD_PUT_PIXEL(byte x, byte y);
void gLCD_line(byte x1, byte y1, byte x2, byte y2);
void print_graf_8x16(byte x, byte y, byte c);
void print_char_24x36(byte x, byte y, byte c);
void print_symvol_24x36(byte x, byte y, unsigned char str[]);
void print_char_12x16(byte x, byte y, byte c);
void print_symvol_12x16(byte x, byte y, unsigned char str[]);
void print_char_12x16_inv(byte x, byte y, byte c);
void print_symvol_12x16_inv(byte x, byte y, unsigned char str[]);
void print_char(char c);
void print_symvol(unsigned char str[]);
void print_char_inv(char c);
void print_symvol_inv(unsigned char str[]);
void beep(int ms_beep);
void upr_light (void);
void upr_dwornikami (void);
void wkluchenie (void);
void obnulenie  (void);


//=====     =====
unsigned long  km_stab;
unsigned long  km;
unsigned long  ovf, freq;
unsigned long  km_print, km_print_stab;
bit speed_ok;
register unsigned int num;
byte s_km, speed, speed_timeout;
byte anti_freeze_counter;
unsigned int F[5];
byte analog_speed_on=0;                  //   (, )
unsigned long kalibrovka;
unsigned int kalibrovka_sp;
eeprom  byte analog_speed_on_save=0;     //   
eeprom  unsigned int kalibrovka_save;    //   
eeprom  unsigned int kalibrovka_sp_save; //   
eeprom  unsigned long  km_save=0;     // 
eeprom  unsigned long  km_stab_save=0;//  
//eeprom  unsigned long  km_stab_save1=0;//  

//======     =====
unsigned int F_t[5], taxo;
byte taxo_time=10;
register bit taxo_ok;
int FrqMn=0;
int sbor;
//===============================================
/* DS18B20 devices ROM code storage area */
unsigned char rom_code[8][9];
unsigned char devices;
int temp=1, temp_test;
byte temp_interval;
//========================================================
unsigned char lcd_buffer[30];
//char bitaddr;
//====================  =========================
    //===== ========
    byte zamena_masla;
    eeprom byte zamena_masla_save;                // ,   
    eeprom unsigned long int od_zamena_pri_save;  //       


char tmp_t[] = {200,200,200,200,200};
int FrqMn_tmp=100;
int temp_tmp_t;
bit swet, gabarit;
byte wubor_w_teme, thema;
eeprom byte wubor_w_teme_save;
eeprom byte thema_save;
bit wozwrat;
//===================================================
byte h,m,s;
byte date, month, year;
byte time_out;
//============== =========================
int podswet_time;                      //  
byte s_light, m_light;
bit read_time;
byte lighton_count1=20,  lighton_count2;
int  lightoff_count1, lightoff_count;
byte auto_light=1;                      //   (  )
byte light1=36;       		        //     
byte light2=33;       		        //     
bit  rux=0; 	                        //    
eeprom byte light1_save=33;	        //     
eeprom byte light2_save=36;	        //     
eeprom byte auto_light_save=1;		//    EEProm (  )

//====================    ========================
byte sensor_rain;
byte dwornik;
byte rain_on;
//==========
byte raznica1, raznica2;
byte control_time;
byte rain_time_speed=70;
//==========
byte podogrew_time;  // ()   
bit podogrew_stop;
//int tmp_rain,tmp_rain0;
bit rain_lcd;
byte dwornik_time;
byte dwornik_stop_time;
eeprom byte sensor_rain_save;
eeprom byte dwornik_save;
eeprom byte rain_on_save;
eeprom unsigned char rain_off_save;
//===================dop swet==============================
 bit dop_swet;
 eeprom byte dop_swet_save;

#define dop_swet_on  (PORTG|=(1<<0))           //PORTG.0    .
#define dop_swet_off (PORTG&=~(1<<0))
#define podogrew_rain_on      (PORTG|=(1<<1))  //  PORTG.1  
#define podogrew_rain_off     (PORTG&=~(1<<1)) // 
#define d_dvopnikov_on      (PORTG|=(1<<3))    //  PORTG.3    
#define d_dvopnikov_off     (PORTG&=~(1<<3))   // 1 speed
#define d_dvopnikov1_on     (PORTG|=(1<<4))    //  PORTG.4    
#define d_dvopnikov1_off    (PORTG&=~(1<<4))   // 2 speed
#define sensor_rain_led_on  (PORTG|=(1<<2))    //PORTG.2      
#define sensor_rain_led_off (PORTG&=~(1<<2))
//=================== ======================
bit open_door_on=1;                  //   

//==================== ========================
bit pw_on=1;
int time_out_power;

//======================warning===========================
 bit ris; byte zadergka_ris;
 bit ris_sneg;

//=====================Statistika=========================
 bit sbros=1;      //  
 bit clear_sbros=1;
 byte sbros_stat;  //    
 byte stat_time;
 eeprom unsigned long int time_root_motion_save;
 eeprom unsigned long int time_root_save;

#include "opend.h"
#include "menu_set.h"
#include "warning.h"
#include "them.h"


// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
#asm("cli")
    TCCR0=0x00;
    num=TCNT0;
    TCNT0=0;
    km++;
    km_stab++;
    freq=num+(ovf*0xFF);
    ovf=0;
    TCCR0=0x07;
    speed_ok=1;
 #asm("sei")
}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void){
#asm("cli")
   ovf++;
        if (ovf>35)   { TCCR0=0x00;
                        TCNT0=0;
                        freq=1000000;
                        speed_ok=1;
                        ovf=0;}
 #asm("sei")
}


// External Interrupt 1 service routine
//   
interrupt [EXT_INT1] void ext_int1_isr(void){
#asm("cli")
    if(TCCR1B==0x00) { TCCR1B=0x04; return;}
    sbor=TCNT1;
    TCNT1=0;
    taxo_ok=1;
#asm("sei")

}

// Timer1 overflow interrupt service routine
interrupt [TIM1_OVF] void timer1_ovf_isr(void){
#asm("cli")
                  TCCR1B=0x00;
                  TCNT1=0;
                  sbor=0;
                  taxo_ok=1;
#asm("sei")
}

// External Interrupt 2 service routine
interrupt [EXT_INT2] void ext_int2_isr(void){

sbros=0;

}

//   
interrupt [EXT_INT3] void ext_int3_isr(void){
if (PIND.7==0) pw_on=1;
speed_timeout=0;
sleep_disable();
}

interrupt [TIM3_OVF] void timer3_ovf_isr(void)
{
//TIMER3 has overflowed
 TCNT3H = 0xF9; //reload counter high value
 TCNT3L = 0xE6; //reload counter low value
 dwornik_time++;
}

void init (void){

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=Out Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=P State6=1 State5=T State4=T State3=T State2=T State1=T State0=T
PORTA=0xC0;
DDRA=0x40;

// Port B initialization
// Func7=Out Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=0 State6=P State5=P State4=P State3=P State2=P State1=P State0=P
PORTB=0x7F;
DDRB=0x80;

// Port C initialization
// Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=Out Func1=Out Func0=Out
// State7=T State6=T State5=1 State4=T State3=1 State2=1 State1=1 State0=1
PORTC=0x0F;
DDRC=0x0F;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
// State7=0 State6=0 State5=0 State4=0 State3=T State2=P State1=P State0=P
PORTD=0x07;
DDRD=0xF0;

// Port G initialization
// Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
// State4=0 State3=0 State2=0 State1=0 State0=0
PORTG=0x00;
DDRG=0x1F;

 // Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
// Mode: Normal top=0xFF
// OC0 output: Disconnected
ASSR=0x00;
TCCR0=0x07;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 62,500 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// OC1C output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x04;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
OCR1CH=0x00;
OCR1CL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz
// Mode: Fast PWM top=FFh
// OC2 output: Non-Inverted PWM
TCCR2=0x00; //TCCR2=0x6D;
TCNT2=0x00;
OCR2=0x00;

//TIMER3 initialize - prescale:1024
// WGM: 0) Normal, TOP=0xFFFF
// desired value: 10Hz
// actual value: 10,003Hz (0,0%)

 TCCR3B = 0x00; //stop
 TCNT3H = 0xF9; //setup
 TCNT3L = 0xE6;
 OCR3AH = 0x06;
 OCR3AL = 0x1A;
 OCR3BH = 0x06;
 OCR3BL = 0x1A;
 OCR3CH = 0x06;
 OCR3CL = 0x1A;
 ICR3H  = 0x06;
 ICR3L  = 0x1A;
 TCCR3A = 0x00;
// TCCR3B = 0x05; //start Timer



// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: On
// INT1 Mode: Rising Edge
// INT2: On
// INT2 Mode: Falling Edge
// INT3: On
// INT3 Mode: Rising Edge
// INT4: Off
// INT5: Off
// INT6: Off
// INT7: Off
EICRA=0xEF;
EICRB=0x00;
EIMSK=0x0F;
EIFR=0x0F;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x05;
ETIMSK=0x04;

// USART0 initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART0 Receiver: On
// USART0 Transmitter: On
// USART0 Mode: Asynchronous
// USART0 Baud Rate: 9600
UCSR0A=0x00;
UCSR0B=0x18;
UCSR0C=0x06;
UBRR0H=0x00;
UBRR0L=0x33;

// ADC initialization
// ADC Clock frequency: 250,000 kHz
// ADC Voltage Reference: Int., cap. on AREF
// ADC High Speed Mode: On
// ADC Auto Trigger Source: Free Running
// Only the 8 most significant bits of
// the AD conversion result are used
ADMUX=ADC_VREF_TYPE;
ADCSRA=0x86;
SFIOR&=0x0F;
SFIOR|=0x10;

// detect how many DS18B20 devices are connected to the 1 Wire bus
devices=w1_search(0xf0,rom_code);
//temp=ds18b20_temperature(&rom_code[0][0]);

// DS1302 Real Time Clock initialization
// Trickle charger: Off
rtc_init(0,0,0);
delay_ms(5);
rtc_get_time(&h,&m,&s);
rtc_get_date(&date,&month,&year);//  


// Global enable interrupts
#asm("sei")
}
//----------------------  --------------------------------
void calc_speed(void)
{
   s_km=kalibrovka_sp/freq;   //kalibrovka_sp=15625  
   speed_ok=0;
   if (s_km==0){F[0]=F[1]=F[2]=F[3]=F[4]=0;}
   else if (s_km>=200) s_km=0;
    if (((F[0]!=s_km)&(F[1]!=s_km)&(F[2]!= s_km)&(F[3]!= s_km)&(F[4]!= s_km))
    |(s_km == 0)
    |(F[0]&F[1]&F[2]&F[3]&F[4] == 0)
    |(anti_freeze_counter > 7)
    )
        {
        F[4] = F[3];
        F[3] = F[2];
        F[2] = F[1];
        F[1] = F[0];
        F[0] = s_km;
        anti_freeze_counter=0;
        }
    else anti_freeze_counter++;

  speed = (F[4] + F[3] + F[2] + F[1] + F[0])/5;

  if (speed<100) OCR2=strelka[speed];
  else  OCR2=speed;

//--------------------   eeprom------------------
//if (sbros==0) km=0;
km_print=km/kalibrovka; //    kalibrovka=3280
km_print_stab=km_stab/(kalibrovka*10);
if (km!=km_save) km_save=km;
if (km_stab_save!=km_stab) km_stab_save=km_stab;
//--------------------------------------------------------------
}

//---------------------- --------------------------------
void calc_taxo (void) {
     // FrqHz=312500/(sbor-1);
     //FrqMn=FrqHz*3;\
      taxo_ok=0;

      if (sbor==0)  {
                  F_t[4]=F_t[3]=F_t[2]=F_t[1]=F_t[0]=0; FrqMn=0; return;}

       taxo=1875000/(sbor-1);// 937500

       if (taxo>9998) { taxo=0; }

       taxo_time++;

       if (taxo_time > 3){
  //    if (((F_t[0]!=taxo)&(F_t[1]!=taxo)&(F_t[2]!= taxo)&(F_t[3]!= taxo)&(F_t[4]!= taxo))
  //  |(taxo == 0)
  //  |(F_t[0]&F_t[1]&F_t[2]&F_t[3]&F_t[4] == 0)
  //  |(taxo_time > 10) )

        F_t[4] = F_t[3];
        F_t[3] = F_t[2];
        F_t[2] = F_t[1];
        F_t[1] = F_t[0];
        F_t[0] = taxo;
        taxo_time=0;
        }

        FrqMn = (F_t[4] + F_t[3] + F_t[2] + F_t[1] + F_t[0])/5;
       if (FrqMn>1800) { FrqMn=(FrqMn/10)*10;} //    1800


//========================================================================
}

// clear LCD
void Lcd_Clear(void){
unsigned int i;
Lcd_Write(CMD,0x40); // Y = 0
Lcd_Write(CMD,0xb0);
Lcd_Write(CMD,0x10); // X = 0
Lcd_Write(CMD,0x00);
Lcd_Write(CMD,0xae); // disable display;
for(i=0;i<864;i++)
Lcd_Write(DATA,0x00);
Lcd_Write(CMD,0xaf); // enable display;
}

// init LCD
void Lcd_Init(void){
cs = 0;
rst = 0;
delay_ms(100);            // 5mS so says the stop watch(less than 5ms will not work)
rst = 1;
Lcd_Write(CMD,0x20); // write VOP register
Lcd_Write(CMD,0x90);
Lcd_Write(CMD,0xA4); // all on/normal display
Lcd_Write(CMD,0x2F); // Power control set(charge pump on/off)
Lcd_Write(CMD,0x40); // set start row address = 0
Lcd_Write(CMD,0xb0); // set Y-address = 0
Lcd_Write(CMD,0x10); // set X-address, upper 3 bits
Lcd_Write(CMD,0x0);  // set X-address, lower 4 bits
Lcd_Write(CMD,0xC8); // mirror Y axis (about X axis)
Lcd_Write(CMD,0xA1); // Invert screen in horizontal axis
Lcd_Write(CMD,0xac); // set initial row (R0) of the display
Lcd_Write(CMD,0x07);
//Lcd_Write(CMD,0xF9); //
Lcd_Write(CMD,0xaf); // display ON/OFF

Lcd_Clear(); // clear LCD
Lcd_Write(CMD,0xa7); // invert display
delay_ms(100);                // 0.1 Sec delay
Lcd_Write(CMD,0xa6); // normal display (non inverted)
delay_ms(100);                // 0.1 Sec delay
}

void Lcd_Write(char cd,unsigned char c){
char i;
    cs = 0;
    sclk = 0;
    sda = cd;
    sclk = 1;

for(i=0;i<8;i++){
        sclk = 0;
            if(c & 0x80)
                sda = 1;
            else
                sda = 0;
        sclk = 1;
        c <<= 1;
        delay_us(40);  //40
                }
        cs = 1;
        }

void SetX(char x){
    Lcd_Write(CMD,0x10 | ((x>>4)&0x7));
    Lcd_Write(CMD,x & 0x0f);
}

/*
void SetY(char y){
//    char aux = 0;
//    while(y>7){
//        y -=8;
//        aux ++;
//    }
//
//    bitaddr = y-1;
//    Lcd_Write(CMD,0xB0 | (aux & 0x0f));
//}
*/
void Gotoxy(byte x,byte y){
        Lcd_Write(CMD,(0xB0|(y&0x0F)));         // Y axis initialisation: 0100 yyyy
        Lcd_Write(CMD,(0x00|(x&0x0F)));         // X axis initialisation: 0000 xxxx ( x3 x2 x1 x0)
        Lcd_Write(CMD,(0x10|((x>>4)&0x07))); // X axis initialisation: 0010 0xxx  ( x6 x5 x4)

}



//   ,    (y0)
void VLine(char x,char y){
    char aux[8];
    char i;

    for(i=0;i<8;i++)
        aux[i] = 0;

    i = 7;
    while(y > 9){
        aux[i] = 0xff;
        y -= 8;
        i--;
    }

    while(y > 0){
        aux[i] >>= 1;
        aux[i] |= 0x80;
        y --;
    }



    for(y=0;y<8;y++){
        Lcd_Write(CMD,0xB0 | y);
        SetX(x);
        Lcd_Write(DATA,aux[y]);
    }

}


/*     1 */
void LCD_PUT_PIXEL(byte x, byte y){
    // 
    byte bite;
    byte page;
    byte data_p=0;
    //     
    if((x>96)|(y>64)) return;

    //page- 
    page=y/8;
    //bite-     
    bite=y%8;

        //data_p=data_p|(1<<bite);
        data_p=data_p^(1<<bite);

    Gotoxy(x,page);
    Lcd_Write(DATA,data_p);
}


/****************************************************************************/
/*                                  */
/*          Input   :    ,              */
/****************************************************************************/
void gLCD_line(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2)
{
	 byte  j;
	 byte x,y;

	if(x1>96 || y1>64) return;
	if(x2>96 || y2>64) return;

	/*
	 * 50 added for good roundings
	 */
	if ((abs((int)x2-(int)x1))>(abs((int)y2-(int)y1)))
	{
		j=x2>x1?1:-1;
		for(x=x1;x!=x2+j;x+=j)
		{
			y=y1+((int)x-(int)x1)/(((int)x2-(int)x1+(x2>x1?1:-1))/((int)y2-(int)y1+(y2>y1?1:-1)));
			if((y2>y1 && y>y2) || (y2<y1 && y<y2)) y=y2;
			LCD_PUT_PIXEL(x,y);
		}
	}
	else
	{
		j=y2>y1?1:-1;
		for(y=y1;y!=y2+j;y+=j)
		{
			x=x1+((int)y-(int)y1)/(((int)y2-(int)y1+(y2>y1?1:-1))/((int)x2-(int)x1+(x2>x1?1:-1)));
			if((x2>x1 && x>x2) || (x2<x1 && x<x2)) x=x2;
			LCD_PUT_PIXEL(x,y);
		}
	}

}



void print_graf_8x16(byte x, byte y, byte c){
    int i;
    Gotoxy(x,y);

    for(i=0; i<8; i++){
        Lcd_Write(DATA,symbol_graf[c][i]);
        }
}

/*  .     24x36 .
============================================================== */
void print_char_24x36(byte x, byte y, byte c){
    byte textL;
    int i;
    //      ,  
    //   
    if(c<0x90) textL=0x20;
    else textL=0x60;
    Gotoxy(x,y);

    for(i=0; i<24; i++){
        Lcd_Write(DATA,FontLookup_24x36[(c - textL)-15][i]);
        }
    Gotoxy(x,y+1);

    for(i=0; i<24; i++){
        Lcd_Write(DATA,FontLookup_24x36[(c - textL)-15][i+24]);
        }
    Gotoxy(x,y+2);

    for(i=0; i<24; i++){
        Lcd_Write(DATA,FontLookup_24x36[(c - textL)-15][i+48]);
        }
    //  
    //LCD_PUT_BYTE(x+i, y+8, 0x00);
    Gotoxy(x,y+3);

    for(i=0; i<24; i++){
        Lcd_Write(DATA,FontLookup_24x36[(c - textL)-15][i+72]);
        }
}
/*     */
void print_symvol_24x36(byte x, byte y, unsigned char str[]){
    byte i=0;
    //     
    while(str[i]){
        print_char_24x36(x+i*23+i, y, str[i]);
        i++;
    }
}

//  .     12x16 .
void print_char_12x16(byte x, byte y, byte c){
    byte textL;
    int i;
    //      ,  
    //   
    if(c<0x90) textL=0x20;
    else textL=0x60;

    Gotoxy(x,y);

    for(i=0; i<12; i++){
        Lcd_Write(DATA,FontLookup_12x16[(c - textL)-14][i]);
        }
    Gotoxy(x,y+1);

    for(i=0; i<12; i++){
        Lcd_Write(DATA,FontLookup_12x16[(c - textL)-14][i+12]);
        }
}
/*     */
void print_symvol_12x16(byte x, byte y, unsigned char str[]){
    byte i=0;
    //     
    while(str[i]){
        print_char_12x16(x+i*11+i, y, str[i]);
        i++;
    }
}

//  .     12x16 .
void print_char_12x16_inv(byte x, byte y, byte c){
    byte textL;
    int i;
    byte FontLookup_12x16_inv;
    //      ,  
    //   
    if(c<0x90) textL=0x20;
    else textL=0x60;

    Gotoxy(x,y);

    for(i=0; i<12; i++){
        FontLookup_12x16_inv=~(FontLookup_12x16[(c - textL)-14][i]);
        Lcd_Write(DATA,FontLookup_12x16_inv);
        }
    Gotoxy(x,y+1);

    for(i=0; i<12; i++){
        FontLookup_12x16_inv=~(FontLookup_12x16[(c - textL)-14][i+12]);
        Lcd_Write(DATA,FontLookup_12x16_inv);
        }
}
/*     */
void print_symvol_12x16_inv(byte x, byte y, unsigned char str[]){
    byte i=0;
    //     
    while(str[i]){
        print_char_12x16_inv(x+i*11+i, y, str[i]);
        i++;
    }
}


void print_char(char c){
   char i;
   //      ,  
   //   
   byte textL;
   if(c<0x90) textL=0x20;
    else textL=0x60;
            for ( i = 0; i < 5; i++ ){
                Lcd_Write(DATA,FontLookup[c - textL][i] << 1);
                }
            Lcd_Write(DATA,0x00);
}

void print_symvol(unsigned char str[]){
   unsigned char i=0;

                   while(str[i]){
                    print_char(str[i]);
                   i++;}
}

void print_char_inv(char c){
   char i;
 byte FontLookup_inv;
   byte textL;
   if(c<0x90) textL=0x20;
    else textL=0x60;
            for ( i = 0; i < 5; i++ ){
                FontLookup_inv=~(FontLookup[c - textL][i] << 1);
                Lcd_Write(DATA,FontLookup_inv);
                }
            Lcd_Write(DATA,0xff);
}

void print_symvol_inv(unsigned char str[]){
   unsigned char i=0;

                   while(str[i]){
                    print_char_inv(str[i]);
                   i++;}
}

//-----------------------------------------  --------------------------------
void beep(int ms_beep)
 {
 int n;
    for(n=0;n<ms_beep; n++){
	PORTD.4=1;
    delay_us(100);
	PORTD.4=0; }
 }

//------------------------------    ------------------------
void upr_light (void){

if (auto_light){

   //printf("  %u   %u  \n\r",lighton_count2, rux );
  //-----------------------------------------   -------------------------------------------
        if   ((read_adc(0)<=light2)&&(read_adc(1)<=light2)) {
           lightoff_count=0;
           if ((rux==0)&&(PIND.6==1)){beep(100); PORTD.6=0; swet=0;}
           if (PIND.6==0){
                 if ((++lighton_count2>50)&&(rux==1)) {
                          PORTD.6=1;
                          beep(100);
                          lighton_count2=0;
                          swet=1;
                         }

                  }
           }

        else if ((read_adc(0)>light2)&&(read_adc(1)>light2)){
           lighton_count2=0;
               if (PIND.6){
        	           if (++lightoff_count>1000) {
                                   lighton_count2=0;
                                   lightoff_count=0;
                                   if (PIND.6==1) {beep(50); PORTD.6=0; swet=0;}
                                   }
                }
        }
//----------------------------   ----------------------------------------
        if   ((read_adc(0)<=light1)&&(read_adc(1)<=light1)) {
                 lightoff_count=0;
                if (PIND.5==0){ lighton_count1++;
                         if (lighton_count1>20) {
                             lighton_count1=0;
                             beep(100); PORTD.5=1; PORTD.7=1; gabarit=1;}

                 }
               	}

        else {
                  lighton_count1=0;
                if (PIND.5){
                           if (lightoff_count1>500){
                              lightoff_count1=0;
                              beep(30); PORTD.5=0; gabarit=0;}
                           lightoff_count1++;
                    }
                if (PIND.7){
                               if (podswet_time>1000) {PORTD.7=0; podswet_time=0;}
                               podswet_time++;
                    }
                    }
               // printf("  %u   %u  \n\r",light1,auto_light );

//-----------------------   ----------------------------------------------

if ((speed>0)&&(rux==0)) {
        rux=1;
        //lighton_count2=50;  lighton_count1=20;
        if   ((read_adc(0)<=light2)&&(read_adc(1)<=light2)) {
                if (PIND.6==0) {PORTD.5=1; PORTD.6=1;PORTD.7=1; beep(500); swet=gabarit=1;}
        }

}
//------------------------------------------------------------------------------------------------
      if ((speed<1)&&(rux==1)){
         if (read_time==0) {s_light=s;
                           if (m<=56) m_light=m+3;
                           else m_light=(m+3)%10;
                           read_time=1;}
         if ((m_light==m)&&(s_light>=s)) {rux=0; read_time=0;}
       // printf("  %d m  %d c \n\r", m, m_light);
          }
      else if (speed>=2){read_time=0;}
//--------------------------------------------------------------------------------------------------
}
//-------------------------------------------------------------------------------------------------
else {
          if ((PIND.5)||(PIND.6)) {PORTD.5=0; PORTD.6=0; gabarit=0; swet=0; rux=0;
                                   lighton_count1=0; lighton_count2=0;}
          if  (PIND.7) { podswet_time++;
                        if (podswet_time>150){ podswet_time=0;
                                               PORTD.7=0;}}
     }

}


//------------------------------    --------------------
void upr_dwornikami (void) {
 static byte control_time_off_lcd;
 static byte run_dwornik;
 byte rain_led_on1, rain_led_on2, rain_led_off1,rain_led_off2;
// byte raznica1, raznica2;

 byte dwornik_pause;

    if (sensor_rain){
      if (run_dwornik==0){   //   
         rain_led_off1=read_adc(3);
         rain_led_off2=read_adc(4);
         dwornik_time=0;

         if((((int)rain_led_off1+(int)rain_on)>=0xfe)||(((int)rain_led_off2+(int)rain_on)>=0xfe)) {
                                control_time=0;
                                control_time_off_lcd=0;
                                rain_lcd=0;
                                d_dvopnikov_off; d_dvopnikov1_off;
                                return;}//   

       sensor_rain_led_on;  //   
            delay_ms(1);
            rain_led_on1=read_adc(3);
            rain_led_on2=read_adc(4);
       sensor_rain_led_off;
            raznica1=rain_led_on1-rain_led_off1;
            raznica2=rain_led_on2-rain_led_off2;
            if((raznica1==0)||(raznica2==0)) {   //    
                                control_time=0;
                                control_time_off_lcd=0;
                                rain_lcd=0;
                                d_dvopnikov_off; d_dvopnikov1_off;
                                return;}

               if((raznica1<=rain_on)&&(raznica2<=rain_on)) {
                    podogrew_rain_on;
                  if (++control_time>rain_time_speed) {
                            rain_lcd=1;
                            control_time=0;
                            control_time_off_lcd=0;
                            TCCR3B = 0x05;  // start Timer
                            run_dwornik=1;  //  
                            }
                            }
               else if((raznica1<=rain_on)||(raznica2<=rain_on)) {
                    podogrew_rain_on;
                  if (++control_time>rain_time_speed) {
                            rain_lcd=1;
                            control_time=0;
                            control_time_off_lcd=0;
                            TCCR3B = 0x05; //start Timer
                            run_dwornik=2;  //  
                            }
                            }
               else {
                  d_dvopnikov1_off;
                  d_dvopnikov_off;
                  control_time=0; rain_time_speed=40;
                  TCCR3B = 0x00; // stop Timer
                  if (rain_lcd){
                      control_time_off_lcd++;
                      if (control_time_off_lcd>200){rain_lcd=0;
                                                    control_time_off_lcd=0; }
                  }
                  }

          }

    }

    else if (dwornik>1) {      //     
             run_dwornik=dwornik+1; }


    else { run_dwornik=0;
           d_dvopnikov1_off;
           d_dvopnikov_off;
           if (podogrew_stop==0) podogrew_rain_off;
           rain_lcd=0; }

    // 
    if  (run_dwornik>0){
         switch (run_dwornik)
         {
            case 1:      //    
                    if ((FrqMn>400)&&(speed>45)){
                                         rain_time_speed=10; d_dvopnikov1_on; d_dvopnikov_off;}
                    else if ((FrqMn>400)&&(speed>20)){
                                         rain_time_speed=20; d_dvopnikov1_on; d_dvopnikov_off;}
                    else if (FrqMn>400){
                                         rain_time_speed=25; d_dvopnikov_on; d_dvopnikov1_off;;
                                            }
                    else {d_dvopnikov1_off; d_dvopnikov_off;}

                    if (dwornik_time>20) {  //25
                                   TCCR3B = 0x00;
                                   run_dwornik=0;}
                    break;

            case 2:     //    
                    if ((FrqMn>400)&&(speed>45)){     rain_time_speed=20;d_dvopnikov1_on; d_dvopnikov_off;}
                    else if ((FrqMn>400)&&(speed>20)){rain_time_speed=30;d_dvopnikov_on; d_dvopnikov1_off;}
                    else if (FrqMn>400){              rain_time_speed=40;d_dvopnikov_on; d_dvopnikov1_off;}
                    else {d_dvopnikov1_off; d_dvopnikov_off;}

                    if (dwornik_time>15) {
                                   TCCR3B = 0x00;
                                   run_dwornik=0;}
                    break;

            case 3:
                  if (speed<5)dwornik_pause=80;
                  else if (speed<15) dwornik_pause=70;
                  else if (speed<25) dwornik_pause=50;
                  else if (speed<40) dwornik_pause=40;
                  else if (speed<60) dwornik_pause=20;
                  else dwornik_pause=10;
                  if (dwornik_time>=dwornik_pause){d_dvopnikov_on;}
                  if (dwornik_time>(dwornik_pause+10)){
                                d_dvopnikov_off;
                                dwornik_time=0;}
                  break;
            case 4:
                  d_dvopnikov_on;
                  d_dvopnikov1_off;
                  break;
            case 5:
                  d_dvopnikov_off;
                  d_dvopnikov1_on;
                  break;

         }
    }

    if (podogrew_time==m) podogrew_stop=0;
    if ((rain_lcd==0)&&(podogrew_stop==0)){podogrew_rain_off;}

}

void wkluchenie (void){

      beep (100);
      PORTD.7=1;

     if (analog_speed_on) TCCR2=0x64;  //       
     else TCCR2=0;


   if ((km_stab/(kalibrovka*10))>999998){km_stab=km_stab_save=0;}

   rux=0;
   F_t[4]=F_t[3]=F_t[2]=F_t[1]=F_t[0]=0; FrqMn=0; //     
   lighton_count1=18;
   lighton_count2=0;
   lightoff_count=0;
   lightoff_count1=0;
   auto_light=auto_light_save;
   sensor_rain=sensor_rain_save;
   ris=0;zadergka_ris=0;


   rtc_get_date(&date,&month,&year);
   rtc_get_time(&h,&m,&s);
   temp=ds18b20_temperature(&rom_code[0][0]);

   //      <11
   if (temp<11){podogrew_rain_on; podogrew_stop=1;
                        if (m>55){ podogrew_time=60-(m+6);}
                        else     { podogrew_time=m+6;     }
   }
   else {podogrew_rain_off; podogrew_stop=0;}

   obnulenie();


     if (zamena_masla){
            km_print_stab=km_stab/(kalibrovka*10);
        if ((od_zamena_pri_save-km_print_stab)<2000){
                         beep (20);
                         Gotoxy (20,0);
                           sprintf (lcd_buffer,"!!!");
                           print_symvol(lcd_buffer);
                           Gotoxy (5,2);
                           sprintf (lcd_buffer,"      :");
                           print_symvol(lcd_buffer);
                           sprintf (lcd_buffer,"%d", od_zamena_pri_save-km_print_stab);
                            print_symvol_12x16(15,5,lcd_buffer);
                           Gotoxy (67,6);
                           sprintf (lcd_buffer,"");
                           print_symvol(lcd_buffer);
                           Gotoxy (5,2);
                           delay_ms(1500);
                        Lcd_Clear();
                        }
                        }
}

void obnulenie (void){
        FrqMn_tmp=100;
        tmp_t[0]=0; tmp_t[1]=100; tmp_t[2]=199;
        tmp_t[3]=100;
        tmp_t[4]=0;
        temp_tmp_t=100;
        podswet_time=0;  wozwrat=0;
}

void main(void) {


  if (wubor_w_teme_save==255) wubor_w_teme_save=0;
  if (thema_save==255) thema_save=0;
  if (light1_save==255) light1_save=36;
  if (light2_save==255) light2_save=33;
  if (auto_light_save==255) auto_light_save=0;
  if (analog_speed_on_save==255) analog_speed_on_save=0;
  if (dwornik_save==255) dwornik_save=0;
  if (sensor_rain_save==255) sensor_rain_save=0;
  if (kalibrovka_save==0xffff) kalibrovka_save=328;
  if (kalibrovka_sp_save==0xffff) kalibrovka_sp_save=15625;
  if (rain_on_save==255) rain_on_save=10;
  if (rain_off_save==255) rain_off_save=20;
  if (zamena_masla_save==255) zamena_masla_save=0;
  if (od_zamena_pri_save==0xffffffff) od_zamena_pri_save=0;
  if (time_root_motion_save==0xffffffff)time_root_motion_save=0;
  if (time_root_save==0xffffffff)time_root_save=0;
  if (dop_swet_save==0xff) dop_swet_save=0;
// =========================================================
// wubor_w_teme_save=0;
// if (thema_save!=0) thema_save=0;
// if (kalibrovka_save!=328) kalibrovka_save=328;
// if (kalibrovka_sp_save!=15625) kalibrovka_sp_save=15625;
// if (light1_save!=33) light1_save=33;
// if (light2_save!=28) light2_save=28;
// auto_light_save=0;
// rain_on_save=50;
// rain_off_save=70;
// zamena_masla_save=0;
// od_zamena_pri_save=0;
//==========================================================
  kalibrovka_sp=kalibrovka_sp_save;
  kalibrovka=kalibrovka_save;
  wubor_w_teme=wubor_w_teme_save;
  light1=light1_save;
  light2=light2_save;
  auto_light=auto_light_save;
  thema=thema_save;
  analog_speed_on=analog_speed_on_save;
  dwornik=dwornik_save;
  sensor_rain=sensor_rain_save;
  rain_on=rain_on_save;
  zamena_masla=zamena_masla_save;
  km=km_save;
  km_stab=km_stab_save;
  dop_swet=dop_swet_save;
  if ((analog_speed_on!=0)&&(analog_speed_on!=1)) analog_speed_on=0;

  init ();
  Lcd_Init();
  Lcd_Clear();
  PORTD.7=1;
  if (s>=60) rtc_set_time(0,10,0); //   
   if ((km/((unsigned long int)kalibrovka))>9998){km=km_save=0;}
   km_stab=km_stab_save;
   if ((km_stab/((unsigned long int)kalibrovka*10))>999998){km_stab=km_stab_save=0;}

   if (analog_speed_on) TCCR2=0x64;  //       

  beep (50);

  while(1){



    if (pw_on==1) {pw_on=0; wkluchenie();}
  //===============  =======================
    if (open_door_on){
          if ((PINA.0==0)||(PINA.1==0)||(PINA.2==0)||(PINA.3==0)||(PINA.4==0)||(PINA.5==0)) {MODE_DOORS_STATE();}
    }

    if ((PINA==0xff)||(PIND.3==0)) open_door_on=1;
  //==============================================================
  //==================  ================================
    if ((PINB.4==0)&&(thema<=1)){while (PINB.4==0){}; delay_us(200);
            beep (100);
            wubor_w_teme++;
            obnulenie();
            if (wubor_w_teme>=4)wubor_w_teme=0;
            wubor_w_teme_save=wubor_w_teme;}

    //   /
    if (PINB.5==0){beep (200); while (PINB.5==0); auto_light^=1;
                   sprintf (lcd_buffer,"///");
                   print_symvol_24x36(0,0,lcd_buffer);
                   Gotoxy (1,0);
                   sprintf (lcd_buffer,"");
                   print_symvol(lcd_buffer);
                   Gotoxy (1,1);
                   sprintf (lcd_buffer,"");
                   print_symvol(lcd_buffer);
                   Gotoxy (3,2);

                   if (auto_light){
                       sprintf (lcd_buffer,"");
                      }

                   else{
                       sprintf (lcd_buffer,"");
                       }
                   print_symvol(lcd_buffer);

                   tmp_t[2]=200;
                   delay_ms(500);
                   Gotoxy (0,0);
                   sprintf (lcd_buffer,"           ");
                   print_symvol(lcd_buffer);
                   Gotoxy (0,1);
                   sprintf (lcd_buffer,"           ");
                   print_symvol(lcd_buffer);
                   Gotoxy (0,2);
                   sprintf (lcd_buffer,"           ");
                   print_symvol(lcd_buffer);
                   }

    //==========    ======================
        if ((PIND.2==0)&&(sbros==0)) {
                    sbros_stat++;
                    if (sbros_stat>=160){
                       sbros_stat=0;
                       sprintf (lcd_buffer,"///");
                       print_symvol_24x36(0,0,lcd_buffer);
                       Gotoxy (1,0);
                       sprintf (lcd_buffer,"");
                       print_symvol(lcd_buffer);
                       Gotoxy (1,1);
                       sprintf (lcd_buffer," ");
                       print_symvol(lcd_buffer);
                       Gotoxy (1,2);
                       sprintf (lcd_buffer,"");
                       print_symvol(lcd_buffer);
                       beep (200);
                       km=km_print=km_save=0;
                       time_root_motion_save=0;
                       time_root_save=0;
                       sbros=1, clear_sbros=0;
                       tmp_t[2]=200;
                       delay_ms(500);
                       Gotoxy (0,1);
                       sprintf (lcd_buffer,"           ");
                       print_symvol(lcd_buffer);
                       Gotoxy (0,2);
                       sprintf (lcd_buffer,"           ");
                       print_symvol(lcd_buffer);
                    }
                    }

    //  
        else if (sbros==0){  beep (200);
                       sprintf (lcd_buffer,"///");
                       print_symvol_24x36(0,0,lcd_buffer);
                       Gotoxy (1,1);
                       sprintf (lcd_buffer,"");
                       print_symvol(lcd_buffer);
                       Gotoxy (1,2);
                       sprintf (lcd_buffer,"");
                       print_symvol(lcd_buffer);
                       km=km_print=km_save=0;
                       sbros=1,sbros_stat=1, clear_sbros=0;
                       tmp_t[2]=200;
                       delay_ms(500);
                       Gotoxy (0,1);
                       sprintf (lcd_buffer,"           ");
                       print_symvol(lcd_buffer);
                       Gotoxy (0,2);
                       sprintf (lcd_buffer,"           ");
                       print_symvol(lcd_buffer);
                       }
       //  printf("1. sbros=%d sbros_stat=%u   \n\r",sbros,sbros_stat);


          if ((PINB.6==0)&&(dwornik==0)){ beep (50); while (PINB.6==0);
                                       if (sensor_rain) sensor_rain=0;
                                       else sensor_rain=1;
                           sprintf (lcd_buffer,"///");
                           print_symvol_24x36(0,0,lcd_buffer);
                           Gotoxy (1,0);
                           sprintf (lcd_buffer,"    ");
                           print_symvol(lcd_buffer);
                           Gotoxy (1,1);
                           sprintf (lcd_buffer,"     ");
                           print_symvol(lcd_buffer);

                           Gotoxy (3,2);
                           if (sensor_rain){
                               sprintf (lcd_buffer,"");
                               }

                           else{
                               TCCR3B = 0x00; //stop Timer
                               dwornik_time=0;//  
                               control_time=0;
                               sprintf (lcd_buffer,"");
                               }
                           print_symvol(lcd_buffer);
                           tmp_t[2]=200;
                           delay_ms(500);
                           Gotoxy (0,0);
                           sprintf (lcd_buffer,"           ");
                           print_symvol(lcd_buffer);
                           Gotoxy (0,1);
                           sprintf (lcd_buffer,"           ");
                           print_symvol(lcd_buffer);
                           Gotoxy (0,2);
                           sprintf (lcd_buffer,"           ");
                           print_symvol(lcd_buffer);
                           }

          else  if ((PINB.6==0)&&(dwornik>0)){ beep (50);
                           while (PINB.6==0){delay_ms(10);dwornik_stop_time++;}
                          if (dwornik_stop_time>100){dwornik=0;}
                          dwornik_stop_time=0;
                                       dwornik++;
                                       if (dwornik>4) dwornik=1;
                           sprintf (lcd_buffer,"///");
                           print_symvol_24x36(0,0,lcd_buffer);
                           Gotoxy (1,0);
                           sprintf (lcd_buffer,"");
                           print_symvol(lcd_buffer);
                           Gotoxy (1,1);
                           sprintf (lcd_buffer,"");
                           print_symvol(lcd_buffer);

                           Gotoxy (3,2);
                              switch (dwornik) {
                                case 1:
                                    TCCR3B = 0x00; //stop Timer
                                    sprintf (lcd_buffer,"");
                                  break;

                                case 2:
                                     TCCR3B = 0x05; //start Timer
                                     if (speed<5) dwornik_time=50;
                                     else if (speed<15) dwornik_time=40;
                                      else if (speed<25) dwornik_time=30;
                                      else if (speed<40) dwornik_time=20;
                                      else dwornik_time=15;
                                     sprintf (lcd_buffer,"");
                                  break;

                                case 3:
                                     TCCR3B = 0x00; //stop Timer
                                     sprintf (lcd_buffer," 1");
                                  break;

                                case 4:
                                      TCCR3B = 0x00; //stop Timer
                                      sprintf (lcd_buffer," 2");
                                  break;
                                };

                            print_symvol(lcd_buffer);
                           tmp_t[2]=200;
                           delay_ms(500);
                           Gotoxy (0,0);
                           sprintf (lcd_buffer,"           ");
                           print_symvol(lcd_buffer);
                           Gotoxy (0,1);
                           sprintf (lcd_buffer,"           ");
                           print_symvol(lcd_buffer);
                           Gotoxy (0,2);
                           sprintf (lcd_buffer,"           ");
                           print_symvol(lcd_buffer);

                           }


     if  (temp_interval>240) {
                temp_interval=0;
                temp_test=ds18b20_temperature(&rom_code[0][0]);
                if ((temp_test>-50)&&(temp_test<70)) temp=temp_test;
                }
     else temp_interval++;

     if ((temp==2)||(temp==0)||(temp==-2)||(temp==-4)){
                if (ris_sneg==0) print_sneg(27,0);}
     else ris_sneg=0;

     if (PINA.7==0) {beep (50); PORTD.7=1; while (PINA.7==0){}; delay_us(200); menu_setup();}

     speed_timeout++;
     if (speed_timeout>20) {
                             speed_timeout=20;}
     if ((speed_ok)&&(speed_timeout==20))   calc_speed();
     if (taxo_ok)    calc_taxo ();

     time_out++;
     if (time_out>30){ time_out=0; rtc_get_time(&h,&m,&s);}

// ==============================================
      if (stat_time!=m){
                    stat_time=m;
                    if(FrqMn>500){time_root_save++;}
                    if(speed>0)  {time_root_motion_save++;}
                    }
// printf(" time_root_save=%u  time_root_motion_save=%u  \n\r",time_root_save, time_root_motion_save);       // %e  Float

   //===============  =================================
      if (PIND.3==0){
            PORTD.7=1; //   
            PORTD.6=0; PORTD.5=0; gabarit=0; swet=0; rain_lcd=0;
            d_dvopnikov_off; d_dvopnikov1_off; dop_swet_off;
                    lighton_count1=0;
                    lighton_count2=0;
                    lightoff_count=0;
                    lightoff_count1=0;
                    speed=0; OCR2=0;

            time_out_power++;

            if (time_out_power>700){
                    time_out_power=0;
                    PORTD.7=0;
                    Lcd_Clear();
                    open_door_on=1;  podogrew_rain_off;
                    obnulenie();
                    sleep_enable();
                    powerdown(); }
      }

      else {
           time_out_power=0;
           upr_light();           //  
           upr_dwornikami();      //  
       }
   if (dop_swet){
      if ((FrqMn>500)&&(speed>1)){dop_swet_on;}
      else if (FrqMn==0){dop_swet_off;}}


   switch (thema) {
    case 0: thema_0 ();
        break;

    case 1: thema_1 ();
       break;

    case 2: thema_2 ();
       break;

    case 3: thema_3 ();
       break;

    default: thema_0 ();
    };

  }
  }